FileProject/Controllers/SaveFileController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using FileProject.Models;
using Dapper;
using System.Data;
using System.Data.SqlClient;
using System.Configuration;
using System.IO;
using System.Net;

namespace FileProject.Controllers
{
    public class SaveFileController : Controller
    {
        // GET: SaveFile
        public ActionResult Index()
        {
            return View();
        }


        public ActionResult Files()
        {
            return View();
        }

        [HttpPost]
        public ActionResult Files(FileData data, string Save)
        {

            //Checking Database for MAX SN using dapper.
            int tempSN;
            try
            {
                using (IDbConnection db = new SqlConnection(ConfigurationManager.ConnectionStrings["DefaultConnection"].ConnectionString))
                {
                    tempSN = db.Query<FileData>(@"select Top 1 SN from FileData Order By SN Desc;").SingleOrDefault().SN;
                }
            }
            //if no data TempSN = 1

            catch (Exception)
            {
                tempSN = 0;
            }

            //creating Random number
            //Random rnd = new Random();
            //int rand = rnd.Next(1, 5);


            int SN = tempSN + 1;
            string SNstring = Convert.ToString(SN);

            //path is defined in web.config     <add key="UserImagePath" value="D:\FileProject\FileProject\StorageFile\" />
            string UploadPath = ConfigurationManager.AppSettings["FilePath"].ToString();
            string ShowPath = ConfigurationManager.AppSettings["ShowPath"].ToString();

            string PhotoFileName = "";
            string CertificateFileName = "";

            string PhotoExtension = "";
            string CertificateExtension = "";

            if (data.PhotoFile != null)
            {
                PhotoExtension = Path.GetExtension(data.PhotoFile.FileName);
                PhotoFileName = SNstring + "-" + "PhotoFile" + PhotoExtension;
                data.PhotoPath = UploadPath + PhotoFileName;
                data.ShowPhotoPath = ShowPath + PhotoFileName;

            }
            if (data.CertificateFile != null)
            {
                CertificateExtension = Path.GetExtension(data.CertificateFile.FileName);
                CertificateFileName = SNstring + "-" + "CertificateFile" + CertificateExtension;
                data.CertificatePath = UploadPath + CertificateFileName;
                data.ShowCertificatePath = ShowPath + CertificateFileName;

            }

            string photoPath = data.PhotoPath;
            string certificatePath = data.CertificatePath;
            string showPhotoPath = data.ShowPhotoPath;
            string showCertificatePath = data.ShowCertificatePath;

            if (Save != null)
            {
                //storing location of data in Database.



                using (IDbConnection db = new SqlConnection(ConfigurationManager.ConnectionStrings["DefaultConnection"].ConnectionString))
                {

                    db.Query<FileData>(@"INSERT INTO FileData (SN, PhotoPath,PhotoName, CertificatePath, CertificateName, ShowPhotoPath,ShowCertificatePath) VALUES (@SN, @photoPath, @PhotoFileName, @certificatePath,@CertificateFileName,@showPhotoPath,@showCertificatePath)", new { SN, photoPath, PhotoFileName, certificatePath , CertificateFileName, showPhotoPath, showCertificatePath });

                }

                //Storing data in folder.

                if (data.PhotoFile != null)
                {
                    data.PhotoFile.SaveAs(data.PhotoPath);
                }
                if (data.CertificateFile != null)
                {
                    data.CertificateFile.SaveAs(data.CertificatePath);
                }

                return View("Success");
            }
            return View();
        }


        public ActionResult Detail(string Btn, int? SN, int? stat)
        {
            try
            {
                int tsn;
                using (IDbConnection db = new SqlConnection(ConfigurationManager.ConnectionStrings["DefaultConnection"].ConnectionString))
                {
                    tsn = db.Query<FileData>(@"Select * from FileData where SN=@SN", new { SN }).SingleOrDefault().SN;
                }
            }
            catch (Exception)
            {
                stat = 1;
            }
            if (Btn != null)
            {
                if(stat ==1)
                {
                    FileData fileData = new FileData();
                    fileData.Error = "Enter Correct SN.";
                    return View(fileData);
                }
                return RedirectToAction("Show", new { SN });
            }
            
            return View();
        }
        public ActionResult Show(int? SN, string saveBtn , FileData data , string cnBtn)
        {
            FileData fileData = new FileData();
            using (IDbConnection db = new SqlConnection(ConfigurationManager.ConnectionStrings["DefaultConnection"].ConnectionString))
            {
                fileData = db.Query<FileData>(@"Select * From FileData where SN = @SN", new { SN }).SingleOrDefault();
            }

            if(saveBtn != null)
            {
                string UploadPath = ConfigurationManager.AppSettings["FilePath"].ToString();
                string ShowPath = ConfigurationManager.AppSettings["ShowPath"].ToString();

                string SNstring = Convert.ToString(SN);

                if (data.PhotoFile != null)
                {
                    var path = fileData.PhotoPath;
                    if (System.IO.File.Exists(path))
                    {
                        System.IO.File.Delete(path);
                        using (IDbConnection db = new SqlConnection(ConfigurationManager.ConnectionStrings["DefaultConnection"].ConnectionString))
                        {
                            db.Query<FileData>(@"Update FileData Set PhotoPath = NULL, ShowPhotoPath = NULL, PhotoName = NULL where SN=@SN", new { SN });
                        }
                    }

                    string PhotoFileName = "";
                    string PhotoExtension = "";
                    PhotoExtension = Path.GetExtension(data.PhotoFile.FileName);
                    PhotoFileName = SNstring + "-" + "PhotoFile" + PhotoExtension;
                    data.PhotoPath = UploadPath + PhotoFileName;
                    data.ShowPhotoPath = ShowPath + PhotoFileName;

                    string photoPath = data.PhotoPath;
                    string showPhotoPath = data.ShowPhotoPath;

                    using (IDbConnection db = new SqlConnection(ConfigurationManager.ConnectionStrings["DefaultConnection"].ConnectionString))
                    {
                        db.Query<FileData>(@"Update FileData Set PhotoPath = @photoPath, PhotoName = @PhotoFileName, ShowPhotoPath = @showPhotoPath where SN = @SN", new { photoPath, PhotoFileName, showPhotoPath, SN });
                    }
                    data.PhotoFile.SaveAs(data.PhotoPath);
                }
                if (data.CertificateFile != null)
                {
                    var path = fileData.CertificatePath;
                    if (System.IO.File.Exists(path))
                    {
                        System.IO.File.Delete(path);
                        using (IDbConnection db = new SqlConnection(ConfigurationManager.ConnectionStrings["DefaultConnection"].ConnectionString))
                        {
                            db.Query<FileData>(@"Update FileData Set CertificatePath = NULL, ShowCertificatePath = NULL, CertificateName = NULL where SN=@SN", new { SN });
                        }
                    }
                    string CertificateFileName = "";
                    string CertificateExtension = "";
                    CertificateExtension = Path.GetExtension(data.CertificateFile.FileName);
                    CertificateFileName = SNstring + "-" + "CertificateFile" + CertificateExtension;
                    data.CertificatePath = UploadPath + CertificateFileName;
                    data.ShowCertificatePath = ShowPath + CertificateFileName;

                    string showCertificatePath = data.ShowCertificatePath;
                    string certificatePath = data.CertificatePath;
                    using (IDbConnection db = new SqlConnection(ConfigurationManager.ConnectionStrings["DefaultConnection"].ConnectionString))
                    {
                        db.Query<FileData>(@"Update FileData Set CertificatePath = @certificatePath, CertificateName = @CertificateFileName, ShowCertificatePath = @showCertificatePath where SN = @SN", new { certificatePath, CertificateFileName, showCertificatePath, SN });
                    }
                    data.CertificateFile.SaveAs(data.CertificatePath);
                }
                return View("Detail");


            }
            if(cnBtn!= null)
            {
                return RedirectToAction("Detail");
            }
            return View(fileData);
        }

        [HttpPost]
        public JsonResult DeleteFile(string SN)
        {
            FileData fileData = new FileData();
            using (IDbConnection db = new SqlConnection(ConfigurationManager.ConnectionStrings["DefaultConnection"].ConnectionString))
            {
                fileData = db.Query<FileData>(@"Select * From FileData where SN = @SN", new {SN }).SingleOrDefault();
            }
            var path = fileData.PhotoPath;
            if (System.IO.File.Exists(path))
            {
                System.IO.File.Delete(path);
                using (IDbConnection db = new SqlConnection(ConfigurationManager.ConnectionStrings["DefaultConnection"].ConnectionString))
                { 

FileProject/Views/SaveFile/Detail.cshtml
@model FileProject.Models.FileData

@{
    ViewBag.Title = "Files";
    Layout = "~/Views/Shared/_Layout.cshtml";
}


<script src="~/Scripts/jquery-3.3.1.js"></script>
<div>
    <h1>
        Search to view and edit
    </h1>
</div>

@using (Html.BeginForm("Detail", "SaveFile", FormMethod.Post))
{
    @Html.AntiForgeryToken()
    <div class="form-horizontal">
        @Html.ValidationSummary(true, "", new { @class = "text-danger" })
        <div class="form-group" id="detail_id">
            @Html.LabelFor(model => model.SN, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.SN, new { htmlAttributes = new { @class = "form-control", @id = "detail" } })<p style="color:red;">@Html.DisplayFor(model => model.Error)</p>
                @Html.ValidationMessageFor(model => model.SN, "", new { @class = "text-danger" })
            </div>
        </div>
        <div class="form-group">
            <div class="col-md-offset-2 col-md-10">
                <input type="submit" name="Btn" value='Search' class="btn btn-default1" />

            </div>
        </div>
    </div>
}

FileProject/Views/SaveFile/Files.cshtml
@model FileProject.Models.FileData
@{
    ViewBag.Title = "Files";
    Layout = "~/Views/Shared/_Layout.cshtml";
}
<h2>Files</h2>
@using (Html.BeginForm("Files", "SaveFile", FormMethod.Post, new
{
    enctype = "multipart/form-data"
}))
{
    @Html.AntiForgeryToken()
    <div class="form-horizontal">
        <hr />
        @Html.ValidationSummary(true, "", new { @class = "text-danger" })
        <div class="form-group" id="F101">
            @Html.LabelFor(model => model.PhotoPath, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                <input type="file" name="PhotoFile" id="PhotoPath" class="custom-file-input" accept="application/pdf" />
                <input type="text" id="txtFileName" name="txtFileName" />
                @Html.ValidationMessageFor(model => model.PhotoPath, "", new { @class = "text-danger" })
            </div>
        </div>
        <div class="form-group" id="C101">
            @Html.LabelFor(model => model.CertificatePath, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                <input type="file" name="CertificateFile" id="CertificatePath" class="custom-file-input" accept="application/pdf" />
                <input type="text" id="txtFileName1" name="txtFileName1" />
                @Html.ValidationMessageFor(model => model.CertificatePath, "", new { @class = "text-danger" })
            </div>
        </div>
        <table class="table">
            <tbody>
                <tr>
                    <td>
                        <div class="form-group">
                            <div class="col-md-offset-2 col-md-10">
                                <input type="submit" name="Save" value="Finish" class="btn btn-default1" />
                            </div>
                        </div>
                    </td>
                </tr>
            </tbody>
        </table>
    </div>
}
@section Scripts {
<script type="text/javascript">

    $(document).ready(function () {

        $("#txtFileName").hide();
        $("#txtFileName1").hide();

        $('#F101').change(function () {
            var x = $("#PhotoPath").val();
            var fname = (document.getElementById('PhotoPath').value).substring(12);
            var re = /(\.pdf)$/i;
            if (x != null) {
                if (re.exec(fname))
                {
                    document.getElementById('txtFileName').value = (document.getElementById('PhotoPath').value).substring(12);
                    var sizePhoto = $('#PhotoPath')[0].files[0].size;
                    if ( sizePhoto > 1000000) {
                        alert("Please upload file less than 1 MB. Thanks!!");
                        $("#PhotoPath").val("");
                    }
                }
                else
                {
                    $("#PhotoPath").val("");
                    alert("File not supported. Please select Pdf file.");
                }
            }           
        });

        $('#CertificatePath').change(function () {           
            var y = $("#CertificatePath").val();
            var fname = (document.getElementById('CertificatePath').value).substring(12);
            var re = /(\.pdf)$/i;
            
            if (y != null)
            {
                if (re.exec(fname))
                {
                    document.getElementById('txtFileName1').value = (document.getElementById('CertificatePath').value).substring(12);
                    var sizeCertificate = $('#CertificatePath')[0].files[0].size;;
                    if (sizeCertificate > 1000000)
                    {
                        alert("Please upload file less than 1 MB. Thanks!!");
                        $("#CertificatePath").val("");
                     }              
                }
                else
                {
                    $("#CertificatePath").val("");
                    alert("File not supported. Please select Pdf file.");
                }
            }            
        });
    
    });    
</script>

}

FileProject/Views/SaveFile/Show.cshtml
@model FileProject.Models.FileData

@{
    ViewBag.Title = "Show";
}

<h2>EDIT FILE INPUT</h2>

@using (Html.BeginForm("Show", "SaveFile", FormMethod.Post, new
{
    enctype = "multipart/form-data"
}))
{
    @Html.AntiForgeryToken()

    <div class="form-horizontal">
        <hr />
        @Html.ValidationSummary(true, "", new { @class = "text-danger" })

        <div class="form-group" id="sn">
            @Html.LabelFor(model => model.SN, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.SN, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.SN, "", new { @class = "text-danger" })
            </div>
        </div>
        <div class="form-group" id="F101">
            @Html.LabelFor(model => model.PhotoPath, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                <input type="file" name="PhotoFile" id="PhotoPath" class="custom-file-input" accept="application/pdf" />
                <input type="text" id="txtFileName" name="txtFileName" />
                <ul class="attachment" style="list-style: none;">
                    <li id="pli">
                        @{
                            var PhotoSource = Model.ShowPhotoPath == null ? "" : Url.Content(Model.ShowPhotoPath);
                        }
                        <table class="table">
                            <tr>
                                <td>
                                    <a style="font-weight:bold" href="@PhotoSource" target="_blank">@(Model.PhotoName)</a>
                                </td>
                                <td  style="text-align:center;width:25%">
                                    @if (Model.ShowPhotoPath != null)
                                    {
                                        <a href="javascript:void(0);" data-id="@Model.SN" id="deleteItem" class="btn btn-danger">Delete</a>
                                    }
                                </td>
                            </tr>
                        </table>
                    </li>
                </ul>

                @Html.ValidationMessageFor(model => model.PhotoPath, "", new { @class = "text-danger" })
            </div>
        </div>
        <br/>
        <div class="form-group" id="C101">
            @Html.LabelFor(model => model.CertificatePath, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                <input type="file" name="CertificateFile" id="CertificatePath" class="custom-file-input" accept="application/pdf" />
                <input type="text" id="txtFileName1" name="txtFileName1" />
                <ul class="attachment" style="list-style: none;">
                    <li id="cli">
                        @{
                            var CertificateSource = Model.ShowCertificatePath == null ? "" : Url.Content(Model.ShowCertificatePath);
                        }
                        <table class="table">
                            <tr>
                                <td>
                                    <a style="font-weight:bold" href="@CertificateSource" target="_blank">@(Model.CertificateName)</a>
                                </td>
                                <td style="text-align:center;width:25%">
                                    @if (Model.ShowCertificatePath != null)
                                    {
                                        <a href="javascript:void(0);" data-id="@Model.SN" id="deleteCertificate" class="btn btn-danger">Delete</a>
                                    }
                                </td>
                            </tr>
                        </table>                        
                        @*<a style="font-weight:bold" href="@Url.Content(Model.ShowCertificatePath)" target="_blank">@(Model.CertificateName)</a>*@
                    </li>
                </ul>
                @Html.ValidationMessageFor(model => model.CertificatePath, "", new { @class = "text-danger" })
            </div>
        </div>
        <table class="table">
            <tr>
                <td style="text-align:center;width:25%">
                    <input type="submit" name="saveBtn" value="Save" class="btn btn-primary" />
                </td>
                <td style="text-align:center;width:25%">
                    <input type="submit" name="cnBtn" value="Cancel" class="btn btn-danger" />
                </td>
            </tr>
        </table>        
    </div>
}

<div>
    @Html.ActionLink("Back to List", "Index")
</div>

@section Scripts {
<script>
    $("#sn").hide();
    $("#txtFileName").hide();
    $("#txtFileName1").hide();
    $('#F101').change(function () {
        
        var x = $("#PhotoPath").val();
        
        console.log(x);

        var fname = (document.getElementById('PhotoPath').value).substring(12);

            var re = /(\.pdf)$/i;

            if (re.exec(fname)) {

                document.getElementById('txtFileName').value = (document.getElementById('PhotoPath').value).substring(12);
                
                var sizePhoto = $('#PhotoPath')[0].files[0].size;
                if (sizePhoto > 1000000) {
                    alert("Please upload file less than 1 MB. Thanks!!");
                    $("#PhotoPath").val("");
                }
                else {
                    $("#pli").hide();
                }
            }

            else
            {
                $("#PhotoPath").val("");
                alert("File not supported. Please select Pdf file.");
            }
    });

    $('#C101').change(function () {
        
        var y = $("#CertificatePath").val();
        console.log(y);
        var fname = (document.getElementById('CertificatePath').value).substring(12);

            var re = /(\.pdf)$/i;

            if (re.exec(fname))
            {

                document.getElementById('txtFileName1').value = (document.getElementById('CertificatePath').value).substring(12);
                
                var sizeCertificate = $('#CertificatePath')[0].files[0].size;;
                if (sizeCertificate > 1000000) {
                    alert("Please upload file less than 1 MB. Thanks!!");
                    $("#CertificatePath").val("");
                }
                else {
                    $("#cli").hide();
                }
            }
            
            else
            {
                $("#CertificatePath").val("");
                alert("File not supported. Please select Pdf file.");
            } 
    });

    $("#deleteItem").click(function (e) {
           e.preventDefault();
           var $ctrl = $(this);
           if (confirm('Do you really want to delete this file?')) {
               $.ajax({
                   url: '@Url.Action("DeleteFile")',
                   type: 'POST',
                   data: { SN: $(this).data('id') }
               }).done(function (data) {
                   if (data.Result == "OK") {
                       $ctrl.closest('li').remove();
                   }
                   else if (data.Result.Message) {
                       alert(data.Result.Message);
                   }
               }).fail(function () {
                   alert("There is something wrong. Please try again.");
               })

           }
    });
    $("#deleteCertificate").click(function (e) {
           e.preventDefault();
           var $ctrl = $(this);
           if (confirm('Do you really want to delete this file?')) {
               $.ajax({
                   url: '@Url.Action("DeleteCertificate")',
                   type: 'POST',
                   data: { SN: $(this).data('id') }
               }).done(function (data) {
                   if (data.Result == "OK") {
                       $ctrl.closest('li').remove();
                   }
                   else if (data.Result.Message) {
                       alert(data.Result.Message);
                   }
               }).fail(function () {
                   alert("There is something wrong. Please try again.");
               })

           }
       });
      
    </script>

}

FileProject/Views/SaveFile/Success.cshtml
@{
    ViewBag.Title = "Success";
}

<h2>Success</h2>

<div>

    @Html.ActionLink("Another File ", "Files", "SaveFile")



</div>